{ --------------------------------------------------------------------------- }
{                       The Game of JETAN -- Version 2.2                      }
{                            Copyright (c)1992 by                             }
{                          Silver Moon Software, Ltd.                         }
{                                                                             }
{    This file contains the definition of the legal moves for the various     }
{  pieces in the game of Jetan. Since pieces can change directions after      }
{  every square, some of the logical conditions for these moves can be        }
{  quite complex.                                                             }
{                                                                             }
{     SOURCE CODE files for Jetan 2.2:                                        }
{         JETAN.PAS -- The main Jetan program                                 }
{         JETANSPR.P -- Contains adaptation of Pavia's Turbo Sprite routines  }
{         JETANGRF.P -- Contains graphics for Jetan board and pieces          }
{         JETAN1.P  -- Contains definition of legal moves for pieces          }
{ --------------------------------------------------------------------------- }
procedure getlegalmoves (k : squarenum; var bd : board; pl : player;
                         var legal : movelist);

procedure chief1;
begin
  with bd do begin
    if target(k + up3left3,bd,pl) then
      if (sq[k + up1left1] = empty) and (sq[k + up2left2] = empty)
       then
        addmove(legal,k,k + up3left3);
    if target(k + up3left2,bd,pl) then
      if ((sq[k + up1] = empty) and (sq[k + up2left1] = empty)) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up2left1] = empty) or (sq[k + up2left2] = empty)))
       then
        addmove(legal,k,k + up3left2);
    if target(k + up3left1,bd,pl) then
      if ((sq[k + left1] = empty) and
          (sq[k + up1left1] = empty) and
          (sq[k + up2left1] = empty)) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up2left2] = empty) or
           (sq[k + up2left1] = empty) or
           (sq[k + up2] = empty))) or
         ((sq[k + up1] = empty) and
          ((sq[k + up2left1] = empty) or (sq[k + up2] = empty))) or
         ((sq[k + up1right1] = empty) and (sq[k + up2] = empty))
       then
        addmove(legal,k,k + up3left1);
    if target(k + up3,bd,pl) then
      if ((sq[k + up1left1] = empty) and
          ((sq[k + up2left1] = empty) or
           (sq[k + up2] = empty))) or
         ((sq[k + up1] = empty) and
          ((sq[k + up2left1] = empty) or
           (sq[k + up2] = empty) or
           (sq[k + up2right1] = empty))) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up2] = empty) or
           (sq[k + up1right1] = empty)))
       then
        addmove(legal,k,k + up3);
    if target(k + up3right1,bd,pl) then
      if ((sq[k + right1] = empty) and
          (sq[k + up1right1] = empty) and
          (sq[k + up2right1] = empty)) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up2right2] = empty) or
           (sq[k + up2right1] = empty) or
           (sq[k + up2] = empty))) or
         ((sq[k + up1] = empty) and
          ((sq[k + up2right1] = empty) or (sq[k + up2] = empty))) or
         ((sq[k + up1left1] = empty) and (sq[k + up2] = empty))
       then
        addmove(legal,k,k + up3right1);
    if target(k + up3right2,bd,pl) then
      if ((sq[k + up1] = empty) and (sq[k + up2right1] = empty)) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up2right1] = empty) or (sq[k + up2right2] = empty)))
       then
        addmove(legal,k,k + up3right2);
    if target(k + up3right3,bd,pl) then
      if (sq[k + up1right1] = empty) and (sq[k + up2right2] = empty)
       then
        addmove(legal,k,k + up3right3);
    if target(k + up2left3,bd,pl) then
      if ((sq[k + left1] = empty) and (sq[k + up1left2] = empty)) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up1left2] = empty) or (sq[k + up2left2] = empty)))
       then
        addmove(legal,k,k + up2left3);
    if target(k + up2left2,bd,pl) then
      if ((sq[k + up1] = empty) and
          ((sq[k + up2left1] = empty) or (sq[k + up1left1] = empty))) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up2left1] = empty) or (sq[k + up1left2] = empty))) or
         ((sq[k + left1] = empty) and
          ((sq[k + up1left2] = empty) or (sq[k + up1left1] = empty)))
       then
        addmove(legal,k,k + up2left2);
    if target(k + up2left1,bd,pl) then
      if ((sq[k + left1] = empty) and
          ((sq[k + up1left2] = empty) or
           (sq[k + up1left1] = empty) or
           (sq[k + up1] = empty))) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up1left2] = empty) or (sq[k + up2left2] = empty) or
           (sq[k + up1] = empty) or (sq[k + up2] = empty))) or
         ((sq[k + up1] = empty) and
          ((sq[k + up1left1] = empty) or (sq[k + up2] = empty))) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up1] = empty) or (sq[k + up2] = empty))) or
         ((sq[k + right1] = empty) and (sq[k + up1] = empty))
       then
        addmove(legal,k,k + up2left1);
    if target(k + up2,bd,pl) then
      if ((sq[k + left1] = empty) and
          ((sq[k + up1left1] = empty) or (sq[k + up1] = empty))) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up2left1] = empty) or (sq[k + up1] = empty))) or
         ((sq[k + up1] = empty) and
          ((sq[k + up2left1] = empty) or (sq[k + up2right1] = empty))) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up2right1] = empty) or (sq[k + up1] = empty))) or
         ((sq[k + right1] = empty) and
          ((sq[k + up1right1] = empty) or (sq[k + up1] = empty)))
       then
        addmove(legal,k,k + up2);
    if target(k + up2right1,bd,pl) then
      if ((sq[k + right1] = empty) and
          ((sq[k + up1right2] = empty) or
           (sq[k + up1right1] = empty) or
           (sq[k + up1] = empty))) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up1right2] = empty) or (sq[k + up2right2] = empty) or
           (sq[k + up1] = empty) or (sq[k + up2] = empty))) or
         ((sq[k + up1] = empty) and
          ((sq[k + up1right1] = empty) or (sq[k + up2] = empty))) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up1] = empty) or (sq[k + up2] = empty))) or
         ((sq[k + left1] = empty) and (sq[k + up1] = empty))
       then
        addmove(legal,k,k + up2right1);
    if target(k + up2right2,bd,pl) then
      if ((sq[k + up1] = empty) and
          ((sq[k + up2right1] = empty) or (sq[k + up1right1] = empty))) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up2right1] = empty) or (sq[k + up1right2] = empty))) or
         ((sq[k + right1] = empty) and
          ((sq[k + up1right2] = empty) or (sq[k + up1right1] = empty)))
       then
        addmove(legal,k,k + up2right2);
    if target(k + up2right3,bd,pl) then
      if ((sq[k + right1] = empty) and (sq[k + up1right2] = empty)) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up1right2] = empty) or (sq[k + up2right2] = empty)))
       then
        addmove(legal,k,k + up2right3);
    if target(k + up1left3,bd,pl) then
      if ((sq[k + up1] = empty) and
          (sq[k + up1left1] = empty) and
          (sq[k + up1left2] = empty)) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up2left2] = empty) or
           (sq[k + up1left2] = empty) or
           (sq[k + left2] = empty))) or
         ((sq[k + left1] = empty) and
          ((sq[k + up1left2] = empty) or (sq[k + left2] = empty))) or
         ((sq[k + down1left1] = empty) and (sq[k + left2] = empty))
       then
        addmove(legal,k,k + up1left3);
    if target(k + up1left2,bd,pl) then
      if ((sq[k + up1] = empty) and
          ((sq[k + up2left1] = empty) or
           (sq[k + up1left1] = empty) or
           (sq[k + left1] = empty))) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up2left1] = empty) or (sq[k + up2left2] = empty) or
           (sq[k + left1] = empty) or (sq[k + left2] = empty))) or
         ((sq[k + left1] = empty) and
          ((sq[k + up1left1] = empty) or (sq[k + left2] = empty))) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + left1] = empty) or (sq[k + left2] = empty))) or
         ((sq[k + down1] = empty) and (sq[k + left1] = empty))
       then
        addmove(legal,k,k + up1left2);
    if target(k + up1left1,bd,pl) then
      if ((sq[k + down1] = empty) and (sq[k + left1] = empty)) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + left1] = empty) or (sq[k + left2] = empty))) or
         ((sq[k + left1] = empty) and
          ((sq[k + left2] = empty) or
           (sq[k + up1left2] = empty) or
           (sq[k + up1] = empty))) or
         ((sq[k + up1] = empty) and
          ((sq[k + up2] = empty) or (sq[k + up2left1] = empty))) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up1] = empty) or (sq[k + up2] = empty))) or
         ((sq[k + right1] = empty) and (sq[k + up1] = empty))
       then
        addmove(legal,k,k + up1left1);
    if target(k + up1,bd,pl) then
      if ((sq[k + down1] = empty) and
          ((sq[k + left1] = empty) or (sq[k + right1] = empty))) or
         ((sq[k + down1left1] = empty) and (sq[k + left1] = empty)) or
         ((sq[k + left1] = empty) and (sq[k + up1left1] = empty)) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up2left1] = empty) or (sq[k + up2] = empty))) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up1right1] = empty) or (sq[k + up2] = empty))) or
         ((sq[k + right1] = empty) and (sq[k + up1right1] = empty)) or
         ((sq[k + down1right1] = empty) and (sq[k + right1] = empty))
       then
        addmove(legal,k,k + up1);
    if target(k + up1right1,bd,pl) then
      if ((sq[k + down1] = empty) and (sq[k + right1] = empty)) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + right1] = empty) or (sq[k + right2] = empty))) or
         ((sq[k + right1] = empty) and
          ((sq[k + right2] = empty) or
           (sq[k + up1right2] = empty) or
           (sq[k + up1] = empty))) or
         ((sq[k + up1] = empty) and
          ((sq[k + up2] = empty) or (sq[k + up2right1] = empty))) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up1] = empty) or (sq[k + up2] = empty))) or
         ((sq[k + left1] = empty) and (sq[k + up1] = empty))
       then
        addmove(legal,k,k + up1right1);
    if target(k + up1right2,bd,pl) then
      if ((sq[k + up1] = empty) and
          ((sq[k + up2right1] = empty) or
           (sq[k + up1right1] = empty) or
           (sq[k + right1] = empty))) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up2right1] = empty) or (sq[k + up2right2] = empty) or
           (sq[k + right1] = empty) or (sq[k + right2] = empty))) or
         ((sq[k + right1] = empty) and
          ((sq[k + up1right1] = empty) or (sq[k + right2] = empty))) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + right1] = empty) or (sq[k + right2] = empty))) or
         ((sq[k + down1] = empty) and (sq[k + right1] = empty))
       then
        addmove(legal,k,k + up1right2);
    if target(k + up1right3,bd,pl) then
      if ((sq[k + up1] = empty) and
          (sq[k + up1right1] = empty) and
          (sq[k + up1right2] = empty)) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up2right2] = empty) or
           (sq[k + up1right2] = empty) or
           (sq[k + right2] = empty))) or
         ((sq[k + right1] = empty) and
          ((sq[k + up1right2] = empty) or (sq[k + right2] = empty))) or
         ((sq[k + down1right1] = empty) and (sq[k + right2] = empty))
       then
        addmove(legal,k,k + up1right3);
    if target(k + left3,bd,pl) then
      if ((sq[k + up1left1] = empty) and
          ((sq[k + up1left2] = empty) or
           (sq[k + left2] = empty))) or
         ((sq[k + left1] = empty) and
          ((sq[k + up1left2] = empty) or
           (sq[k + left2] = empty) or
           (sq[k + down1left2] = empty))) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + left2] = empty) or
           (sq[k + down1left2] = empty)))
       then
        addmove(legal,k,k + left3);
    if target(k + left2,bd,pl) then
      if ((sq[k + down1] = empty) and
          ((sq[k + down1left1] = empty) or (sq[k + left1] = empty))) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down1left2] = empty) or (sq[k + left1] = empty))) or
         ((sq[k + left1] = empty) and
          ((sq[k + down1left2] = empty) or (sq[k + up1left2] = empty))) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up1left2] = empty) or (sq[k + left1] = empty))) or
         ((sq[k + up1] = empty) and
          ((sq[k + up1left1] = empty) or (sq[k + left1] = empty)))
       then
        addmove(legal,k,k + left2);
    if target(k + left1,bd,pl) then
      if ((sq[k + right1] = empty) and
          ((sq[k + down1] = empty) or (sq[k + up1] = empty))) or
         ((sq[k + down1right1] = empty) and (sq[k + down1] = empty)) or
         ((sq[k + down1] = empty) and (sq[k + down1left1] = empty)) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down1left2] = empty) or (sq[k + left2] = empty))) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + up1left2] = empty) or (sq[k + left2] = empty))) or
         ((sq[k + up1] = empty) and (sq[k + up1left1] = empty)) or
         ((sq[k + up1right1] = empty) and (sq[k + up1] = empty))
       then
        addmove(legal,k,k + left1)
  end
end; { chief1 }

procedure chief2;
begin
  with bd do begin
    if target(k + right1,bd,pl) then
      if ((sq[k + left1] = empty) and
          ((sq[k + down1] = empty) or (sq[k + up1] = empty))) or
         ((sq[k + down1left1] = empty) and (sq[k + down1] = empty)) or
         ((sq[k + down1] = empty) and (sq[k + down1right1] = empty)) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down1right2] = empty) or (sq[k + right2] = empty))) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up1right2] = empty) or (sq[k + right2] = empty))) or
         ((sq[k + up1] = empty) and (sq[k + up1right1] = empty)) or
         ((sq[k + up1left1] = empty) and (sq[k + up1] = empty))
       then
        addmove(legal,k,k + right1);
    if target(k + right2,bd,pl) then
      if ((sq[k + down1] = empty) and
          ((sq[k + down1right1] = empty) or (sq[k + right1] = empty))) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down1right2] = empty) or (sq[k + right1] = empty))) or
         ((sq[k + right1] = empty) and
          ((sq[k + down1right2] = empty) or (sq[k + up1right2] = empty))) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + up1right2] = empty) or (sq[k + right1] = empty))) or
         ((sq[k + up1] = empty) and
          ((sq[k + up1right1] = empty) or (sq[k + right1] = empty)))
       then
        addmove(legal,k,k + right2);
    if target(k + right3,bd,pl) then
      if ((sq[k + up1right1] = empty) and
          ((sq[k + up1right2] = empty) or
           (sq[k + right2] = empty))) or
         ((sq[k + right1] = empty) and
          ((sq[k + up1right2] = empty) or
           (sq[k + right2] = empty) or
           (sq[k + down1right2] = empty))) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + right2] = empty) or
           (sq[k + down1right2] = empty)))
       then
        addmove(legal,k,k + right3);
    if target(k + down1left3,bd,pl) then
      if ((sq[k + down1] = empty) and
          (sq[k + down1left1] = empty) and
          (sq[k + down1left2] = empty)) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down2left2] = empty) or
           (sq[k + down1left2] = empty) or
           (sq[k + left2] = empty))) or
         ((sq[k + left1] = empty) and
          ((sq[k + down1left2] = empty) or (sq[k + left2] = empty))) or
         ((sq[k + up1left1] = empty) and (sq[k + left2] = empty))
       then
        addmove(legal,k,k + down1left3);
    if target(k + down1left2,bd,pl) then
      if ((sq[k + down1] = empty) and
          ((sq[k + down2left1] = empty) or
           (sq[k + down1left1] = empty) or
           (sq[k + left1] = empty))) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down2left1] = empty) or (sq[k + down2left2] = empty) or
           (sq[k + left1] = empty) or (sq[k + left2] = empty))) or
         ((sq[k + left1] = empty) and
          ((sq[k + down1left1] = empty) or (sq[k + left2] = empty))) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + left1] = empty) or (sq[k + left2] = empty))) or
         ((sq[k + up1] = empty) and (sq[k + left1] = empty))
       then
        addmove(legal,k,k + down1left2);
    if target(k + down1left1,bd,pl) then
      if ((sq[k + up1] = empty) and (sq[k + left1] = empty)) or
         ((sq[k + up1left1] = empty) and
          ((sq[k + left1] = empty) or (sq[k + left2] = empty))) or
         ((sq[k + left1] = empty) and
          ((sq[k + left2] = empty) or
           (sq[k + down1left2] = empty) or
           (sq[k + down1] = empty))) or
         ((sq[k + down1] = empty) and
          ((sq[k + down2] = empty) or (sq[k + down2left1] = empty))) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down1] = empty) or (sq[k + down2] = empty))) or
         ((sq[k + right1] = empty) and (sq[k + down1] = empty))
       then
        addmove(legal,k,k + down1left1);
    if target(k + down1,bd,pl) then
      if ((sq[k + up1] = empty) and
          ((sq[k + left1] = empty) or (sq[k + right1] = empty))) or
         ((sq[k + up1left1] = empty) and (sq[k + left1] = empty)) or
         ((sq[k + left1] = empty) and (sq[k + down1left1] = empty)) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down2left1] = empty) or (sq[k + down2] = empty))) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down1right1] = empty) or (sq[k + down2] = empty))) or
         ((sq[k + right1] = empty) and (sq[k + down1right1] = empty)) or
         ((sq[k + up1right1] = empty) and (sq[k + right1] = empty))
       then
        addmove(legal,k,k + down1);
    if target(k + down1right1,bd,pl) then
      if ((sq[k + up1] = empty) and (sq[k + right1] = empty)) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + right1] = empty) or (sq[k + right2] = empty))) or
         ((sq[k + right1] = empty) and
          ((sq[k + right2] = empty) or
           (sq[k + down1right2] = empty) or
           (sq[k + down1] = empty))) or
         ((sq[k + down1] = empty) and
          ((sq[k + down2] = empty) or (sq[k + down2right1] = empty))) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down1] = empty) or (sq[k + down2] = empty))) or
         ((sq[k + left1] = empty) and (sq[k + down1] = empty))
       then
        addmove(legal,k,k + down1right1);
    if target(k + down1right2,bd,pl) then
      if ((sq[k + down1] = empty) and
          ((sq[k + down2right1] = empty) or
           (sq[k + down1right1] = empty) or
           (sq[k + right1] = empty))) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down2right1] = empty) or (sq[k + down2right2] = empty) or
           (sq[k + right1] = empty) or (sq[k + right2] = empty))) or
         ((sq[k + right1] = empty) and
          ((sq[k + down1right1] = empty) or (sq[k + right2] = empty))) or
         ((sq[k + up1right1] = empty) and
          ((sq[k + right1] = empty) or (sq[k + right2] = empty))) or
         ((sq[k + up1] = empty) and (sq[k + right1] = empty))
       then
        addmove(legal,k,k + down1right2);
    if target(k + down1right3,bd,pl) then
      if ((sq[k + down1] = empty) and
          (sq[k + down1right1] = empty) and
          (sq[k + down1right2] = empty)) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down2right2] = empty) or
           (sq[k + down1right2] = empty) or
           (sq[k + right2] = empty))) or
         ((sq[k + right1] = empty) and
          ((sq[k + down1right2] = empty) or (sq[k + right2] = empty))) or
         ((sq[k + up1right1] = empty) and (sq[k + right2] = empty))
       then
        addmove(legal,k,k + down1right3);
    if target(k + down2left3,bd,pl) then
      if ((sq[k + left1] = empty) and (sq[k + down1left2] = empty)) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down1left2] = empty) or (sq[k + down2left2] = empty)))
       then
        addmove(legal,k,k + down2left3);
    if target(k + down2left2,bd,pl) then
      if ((sq[k + down1] = empty) and
          ((sq[k + down2left1] = empty) or (sq[k + down1left1] = empty))) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down2left1] = empty) or (sq[k + down1left2] = empty))) or
         ((sq[k + left1] = empty) and
          ((sq[k + down1left2] = empty) or (sq[k + down1left1] = empty)))
       then
        addmove(legal,k,k + down2left2);
    if target(k + down2left1,bd,pl) then
      if ((sq[k + left1] = empty) and
          ((sq[k + down1left2] = empty) or
           (sq[k + down1left1] = empty) or
           (sq[k + down1] = empty))) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down1left2] = empty) or (sq[k + down2left2] = empty) or
           (sq[k + down1] = empty) or (sq[k + down2] = empty))) or
         ((sq[k + down1] = empty) and
          ((sq[k + down1left1] = empty) or (sq[k + down2] = empty))) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down1] = empty) or (sq[k + down2] = empty))) or
         ((sq[k + right1] = empty) and (sq[k + down1] = empty))
       then
        addmove(legal,k,k + down2left1);
    if target(k + down2,bd,pl) then
      if ((sq[k + left1] = empty) and
          ((sq[k + down1left1] = empty) or (sq[k + down1] = empty))) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down2left1] = empty) or (sq[k + down1] = empty))) or
         ((sq[k + down1] = empty) and
          ((sq[k + down2left1] = empty) or (sq[k + down2right1] = empty))) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down2right1] = empty) or (sq[k + down1] = empty))) or
         ((sq[k + right1] = empty) and
          ((sq[k + down1right1] = empty) or (sq[k + down1] = empty)))
       then
        addmove(legal,k,k + down2);
    if target(k + down2right1,bd,pl) then
      if ((sq[k + right1] = empty) and
          ((sq[k + down1right2] = empty) or
           (sq[k + down1right1] = empty) or
           (sq[k + down1] = empty))) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down1right2] = empty) or (sq[k + down2right2] = empty) or
           (sq[k + down1] = empty) or (sq[k + down2] = empty))) or
         ((sq[k + down1] = empty) and
          ((sq[k + down1right1] = empty) or (sq[k + down2] = empty))) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down1] = empty) or (sq[k + down2] = empty))) or
         ((sq[k + left1] = empty) and (sq[k + down1] = empty))
       then
        addmove(legal,k,k + down2right1);
    if target(k + down2right2,bd,pl) then
      if ((sq[k + down1] = empty) and
          ((sq[k + down2right1] = empty) or (sq[k + down1right1] = empty))) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down2right1] = empty) or (sq[k + down1right2] = empty))) or
         ((sq[k + right1] = empty) and
          ((sq[k + down1right2] = empty) or (sq[k + down1right1] = empty)))
       then
        addmove(legal,k,k + down2right2);
    if target(k + down2right3,bd,pl) then
      if ((sq[k + right1] = empty) and (sq[k + down1right2] = empty)) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down1right2] = empty) or (sq[k + down2right2] = empty)))
       then
        addmove(legal,k,k + down2right3);
    if target(k + down3left3,bd,pl) then
      if (sq[k + down1left1] = empty) and (sq[k + down2left2] = empty)
       then
        addmove(legal,k,k + down3left3);
    if target(k + down3left2,bd,pl) then
      if ((sq[k + down1] = empty) and (sq[k + down2left1] = empty)) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down2left1] = empty) or (sq[k + down2left2] = empty)))
       then
        addmove(legal,k,k + down3left2);
    if target(k + down3left1,bd,pl) then
      if ((sq[k + left1] = empty) and
          (sq[k + down1left1] = empty) and
          (sq[k + down2left1] = empty)) or
         ((sq[k + down1left1] = empty) and
          ((sq[k + down2left2] = empty) or
           (sq[k + down2left1] = empty) or
           (sq[k + down2] = empty))) or
         ((sq[k + down1] = empty) and
          ((sq[k + down2left1] = empty) or (sq[k + down2] = empty))) or
         ((sq[k + down1right1] = empty) and (sq[k + down2] = empty))
       then
        addmove(legal,k,k + down3left1);
    if target(k + down3,bd,pl) then
      if ((sq[k + down1left1] = empty) and
          ((sq[k + down2left1] = empty) or
           (sq[k + down2] = empty))) or
         ((sq[k + down1] = empty) and
          ((sq[k + down2left1] = empty) or
           (sq[k + down2] = empty) or
           (sq[k + down2right1] = empty))) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down2] = empty) or
           (sq[k + down1right1] = empty)))
       then
        addmove(legal,k,k + down3);
    if target(k + down3right1,bd,pl) then
      if ((sq[k + right1] = empty) and
          (sq[k + down1right1] = empty) and
          (sq[k + down2right1] = empty)) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down2right2] = empty) or
           (sq[k + down2right1] = empty) or
           (sq[k + down2] = empty))) or
         ((sq[k + down1] = empty) and
          ((sq[k + down2right1] = empty) or (sq[k + down2] = empty))) or
         ((sq[k + down1left1] = empty) and (sq[k + down2] = empty))
       then
        addmove(legal,k,k + down3right1);
    if target(k + down3right2,bd,pl) then
      if ((sq[k + down1] = empty) and (sq[k + down2right1] = empty)) or
         ((sq[k + down1right1] = empty) and
          ((sq[k + down2right1] = empty) or (sq[k + down2right2] = empty)))
       then
        addmove(legal,k,k + down3right2);
    if target(k + down3right3,bd,pl) then
      if (sq[k + down1right1] = empty) and (sq[k + down2right2] = empty)
       then
        addmove(legal,k,k + down3right3)
  end
end; { chief2 }

begin
  with bd do begin
    case sq[k] of
      othoat, bthoat :
      begin
        if target(k + up2left1,bd,pl) then
          addmove(legal,k,k + up2left1);
        if target(k + up2right1,bd,pl) then
          addmove(legal,k,k + up2right1);
        if target(k + up1left2,bd,pl) then
          addmove(legal,k,k + up1left2);
        if target(k + up1right2,bd,pl) then
          addmove(legal,k,k + up1right2);
        if target(k + down1left2,bd,pl) then
          addmove(legal,k,k + down1left2);
        if target(k + down1right2,bd,pl) then
          addmove(legal,k,k + down1right2);
        if target(k + down2left1,bd,pl) then
          addmove(legal,k,k + down2left1);
        if target(k + down2right1,bd,pl) then
          addmove(legal,k,k + down2right1);
        if fullthoatmove then begin
          if target(k + up1,bd,pl) then
            addmove(legal,k,k + up1);
          if target(k + left1,bd,pl) then
            addmove(legal,k,k + left1);
          if target(k + right1,bd,pl) then
            addmove(legal,k,k + right1);
          if target(k + down1,bd,pl) then
            addmove(legal,k,k + down1)
        end
      end; { thoat }
      opanthan, bpanthan :
      begin
        if pl = orangepc then begin
          if target(k + down1,bd,pl) then
            addmove(legal,k,k + down1)
        end
        else begin { pl = blackpc }
          if target(k + up1,bd,pl) then
            addmove(legal,k,k + up1)
        end;
        if target(k + up1left1,bd,pl) then
          addmove(legal,k,k + up1left1);
        if target(k + up1right1,bd,pl) then
          addmove(legal,k,k + up1right1);
        if target(k + left1,bd,pl) then
          addmove(legal,k,k + left1);
        if target(k + right1,bd,pl) then
          addmove(legal,k,k + right1);
        if target(k + down1left1,bd,pl) then
          addmove(legal,k,k + down1left1);
        if target(k + down1right1,bd,pl) then
          addmove(legal,k,k + down1right1)
      end; { panthan }
      owarrior, bwarrior :
      begin
        if target(k + up2,bd,pl) then
          if sq[k + up1] = empty then
            addmove(legal,k,k + up2);
        if target(k + up1left1,bd,pl) then
          if (sq[k + up1] = empty) or (sq[k + left1] = empty) then
            addmove(legal,k,k + up1left1);
        if target(k + up1right1,bd,pl) then
          if (sq[k + up1] = empty) or (sq[k + right1] = empty) then
            addmove(legal,k,k + up1right1);
        if target(k + left2,bd,pl) then
          if sq[k + left1] = empty then
            addmove(legal,k,k + left2);
        if target(k + right2,bd,pl) then
          if sq[k + right1] = empty then
            addmove(legal,k,k + right2);
        if target(k + down1left1,bd,pl) then
          if (sq[k + down1] = empty) or (sq[k + left1] = empty) then
            addmove(legal,k,k + down1left1);
        if target(k + down1right1,bd,pl) then
          if (sq[k + down1] = empty) or (sq[k + right1] = empty) then
            addmove(legal,k,k + down1right1);
        if target(k + down2,bd,pl) then
          if sq[k + down1] = empty then
            addmove(legal,k,k + down2)
      end; { warrior }
      opadwar, bpadwar :
      begin
        if target(k + up2left2,bd,pl) then
          if sq[k + up1left1] = empty then
            addmove(legal,k,k + up2left2);
        if target(k + up2,bd,pl) then
          if (sq[k + up1left1] = empty) or (sq[k + up1right1] = empty) then
            addmove(legal,k,k + up2);
        if target(k + up2right2,bd,pl) then
          if sq[k + up1right1] = empty then
            addmove(legal,k,k + up2right2);
        if target(k + left2,bd,pl) then
          if (sq[k + up1left1] = empty) or (sq[k + down1left1] = empty) then
            addmove(legal,k,k + left2);
        if target(k + right2,bd,pl) then
          if (sq[k + up1right1] = empty) or (sq[k + down1right1] = empty) then
            addmove(legal,k,k + right2);
        if target(k + down2left2,bd,pl) then
          if sq[k + down1left1] = empty then
            addmove(legal,k,k + down2left2);
        if target(k + down2,bd,pl) then
          if (sq[k + down1left1] = empty) or (sq[k + down1right1] = empty) then
            addmove(legal,k,k + down2);
        if target(k + down2right2,bd,pl) then
          if sq[k + down1right1] = empty then
            addmove(legal,k,k + down2right2)
      end; { padwar }
      odwar, bdwar :
      begin
        if target(k + up3,bd,pl) then
          if (sq[k + up1] = empty) and (sq[k + up2] = empty) then
            addmove(legal,k,k + up3);
        if target(k + up2left1,bd,pl) then
          if ((sq[k + up1] = empty) and
              ((sq[k + up2] = empty) or (sq[k + up1left1] = empty))) or
             ((sq[k + left1] = empty) and (sq[k + up1left1] = empty)) then
            addmove(legal,k,k + up2left1);
        if target(k + up2right1,bd,pl) then
          if ((sq[k + up1] = empty) and
              ((sq[k + up2] = empty) or (sq[k + up1right1] = empty))) or
             ((sq[k + right1] = empty) and (sq[k + up1right1] = empty)) then
            addmove(legal,k,k + up2right1);
        if target(k + up1left2,bd,pl) then
          if ((sq[k + up1] = empty) and (sq[k + up1left1] = empty)) or
             ((sq[k + left1] = empty) and
              ((sq[k + up1left1] = empty) or (sq[k + left2] = empty))) then
            addmove(legal,k,k + up1left2);
        if target(k + up1,bd,pl) then
          if ((sq[k + left1] = empty) and (sq[k + up1left1] = empty)) or
             ((sq[k + right1] = empty) and (sq[k + up1right1] = empty)) then
            addmove(legal,k,k + up1);
        if target(k + up1right2,bd,pl) then
          if ((sq[k + up1] = empty) and (sq[k + up1right1] = empty)) or
             ((sq[k + right1] = empty) and
              ((sq[k + up1right1] = empty) or (sq[k + right2] = empty))) then
            addmove(legal,k,k + up1right2);
        if target(k + left3,bd,pl) then
          if (sq[k + left1] = empty) and (sq[k + left2] = empty) then
            addmove(legal,k,k + left3);
        if target(k + left1,bd,pl) then
          if ((sq[k + up1] = empty) and (sq[k + up1left1] = empty)) or
             ((sq[k + down1] = empty) and (sq[k + down1left1] = empty)) then
            addmove(legal,k,k + left1);
        if target(k + right1,bd,pl) then
          if ((sq[k + up1] = empty) and (sq[k + up1right1] = empty)) or
             ((sq[k + down1] = empty) and (sq[k + down1right1] = empty)) then
            addmove(legal,k,k + right1);
        if target(k + right3,bd,pl) then
          if (sq[k + right1] = empty) and (sq[k + right3] = empty) then
            addmove(legal,k,k + right3);
        if target(k + down1left2,bd,pl) then
          if ((sq[k + down1] = empty) and (sq[k + down1left1] = empty)) or
             ((sq[k + left1] = empty) and
              ((sq[k + down1left1] = empty) or (sq[k + left2] = empty))) then
            addmove(legal,k,k + down1left2);
        if target(k + down1,bd,pl) then
          if ((sq[k + right1] = empty) and (sq[k + down1right1] = empty)) or
             ((sq[k + left1] = empty) and (sq[k + down1left1] = empty)) then
            addmove(legal,k,k + down1);
        if target(k + down1right2,bd,pl) then
          if ((sq[k + down1] = empty) and (sq[k + down1right1] = empty)) or
             ((sq[k + right1] = empty) and
              ((sq[k + down1right1] = empty) or (sq[k + right2] = empty))) then
            addmove(legal,k,k + down1right2);
        if target(k + down2left1,bd,pl) then
          if ((sq[k + down1] = empty) and
              ((sq[k + down2] = empty) or (sq[k + down1left1] = empty))) or
             ((sq[k + left1] = empty) and (sq[k + down1left1] = empty)) then
            addmove(legal,k,k + down2left1);
        if target(k + down2right1,bd,pl) then
          if ((sq[k + down1] = empty) and
              ((sq[k + down2] = empty) or (sq[k + down1right1] = empty))) or
             ((sq[k + right1] = empty) and (sq[k + down1right1] = empty)) then
            addmove(legal,k,k + down2right1);
        if target(k + down3,bd,pl) then
          if (sq[k + down1] = empty) and (sq[k + down2] = empty) then
            addmove(legal,k,k + down3)
      end; { dwar }
      oflier, bflier :
      begin
        if target(k + up3left3,bd,pl) then
          addmove(legal,k,k + up3left3);
        if target(k + up3left1,bd,pl) then
          addmove(legal,k,k + up3left1);
        if target(k + up3right1,bd,pl) then
          addmove(legal,k,k + up3right1);
        if target(k + up3right3,bd,pl) then
          addmove(legal,k,k + up3right3);
        if target(k + up1left3,bd,pl) then
          addmove(legal,k,k + up1left3);
        if target(k + up1left1,bd,pl) then
          if (k <> 68) and (k <> 204) then
            addmove(legal,k,k + up1left1);
        if target(k + up1right1,bd,pl) then
          if (k <> 75) and (k <> 195) then
            addmove(legal,k,k + up1right1);
        if target(k + up1right3,bd,pl) then
          addmove(legal,k,k + up1right3);
        if target(k + down1left3,bd,pl) then
          addmove(legal,k,k + down1left3);
        if target(k + down1left1,bd,pl) then
          if (k <> 60) and (k <> 180) then
            addmove(legal,k,k + down1left1);
        if target(k + down1right1,bd,pl) then
          if (k <> 51) and (k <> 187) then
            addmove(legal,k,k + down1right1);
        if target(k + down1right3,bd,pl) then
          addmove(legal,k,k + down1right3);
        if target(k + down3left3,bd,pl) then
          addmove(legal,k,k + down3left3);
        if target(k + down3left1,bd,pl) then
          addmove(legal,k,k + down3left1);
        if target(k + down3right1,bd,pl) then
          addmove(legal,k,k + down3right1);
        if target(k + down3right3,bd,pl) then
          addmove(legal,k,k + down3right3)
      end; { flier }
      oprincess, bprincess :
      begin
        if sq[k + up3left3] = empty then
          addmove(legal,k,k + up3left3);
        if sq[k + up3left2] = empty then
          addmove(legal,k,k + up3left2);
        if sq[k + up3left1] = empty then
          addmove(legal,k,k + up3left1);
        if sq[k + up3] = empty then
          addmove(legal,k,k + up3);
        if sq[k + up3right1] = empty then
          addmove(legal,k,k + up3right1);
        if sq[k + up3right2] = empty then
          addmove(legal,k,k + up3right2);
        if sq[k + up3right3] = empty then
          addmove(legal,k,k + up3right3);
        if sq[k + up2left3] = empty then
          addmove(legal,k,k + up2left3);
        if sq[k + up2left2] = empty then
          addmove(legal,k,k + up2left2);
        if sq[k + up2left1] = empty then
          addmove(legal,k,k + up2left1);
        if sq[k + up2] = empty then
          addmove(legal,k,k + up2);
        if sq[k + up2right1] = empty then
          addmove(legal,k,k + up2right1);
        if sq[k + up2right2] = empty then
          addmove(legal,k,k + up2right2);
        if sq[k + up2right3] = empty then
          addmove(legal,k,k + up2right3);
        if sq[k + up1left3] = empty then
          addmove(legal,k,k + up1left3);
        if sq[k + up1left2] = empty then
          addmove(legal,k,k + up1left2);
        if sq[k + up1left1] = empty then
          addmove(legal,k,k + up1left1);
        if sq[k + up1] = empty then
          addmove(legal,k,k + up1);
        if sq[k + up1right1] = empty then
          addmove(legal,k,k + up1right1);
        if sq[k + up1right2] = empty then
          addmove(legal,k,k + up1right2);
        if sq[k + up1right3] = empty then
          addmove(legal,k,k + up1right3);
        if sq[k + left3] = empty then
          addmove(legal,k,k + left3);
        if sq[k + left2] = empty then
          addmove(legal,k,k + left2);
        if sq[k + left1] = empty then
          addmove(legal,k,k + left1);
        if sq[k + right1] = empty then
          addmove(legal,k,k + right1);
        if sq[k + right2] = empty then
          addmove(legal,k,k + right2);
        if sq[k + right3] = empty then
          addmove(legal,k,k + right3);
        if sq[k + down1left3] = empty then
          addmove(legal,k,k + down1left3);
        if sq[k + down1left2] = empty then
          addmove(legal,k,k + down1left2);
        if sq[k + down1left1] = empty then
          addmove(legal,k,k + down1left1);
        if sq[k + down1] = empty then
          addmove(legal,k,k + down1);
        if sq[k + down1right1] = empty then
          addmove(legal,k,k + down1right1);
        if sq[k + down1right2] = empty then
          addmove(legal,k,k + down1right2);
        if sq[k + down1right3] = empty then
          addmove(legal,k,k + down1right3);
        if sq[k + down2left3] = empty then
          addmove(legal,k,k + down2left3);
        if sq[k + down2left2] = empty then
          addmove(legal,k,k + down2left2);
        if sq[k + down2left1] = empty then
          addmove(legal,k,k + down2left1);
        if sq[k + down2] = empty then
          addmove(legal,k,k + down2);
        if sq[k + down2right1] = empty then
          addmove(legal,k,k + down2right1);
        if sq[k + down2right2] = empty then
          addmove(legal,k,k + down2right2);
        if sq[k + down2right3] = empty then
          addmove(legal,k,k + down2right3);
        if sq[k + down3left3] = empty then
          addmove(legal,k,k + down3left3);
        if sq[k + down3left2] = empty then
          addmove(legal,k,k + down3left2);
        if sq[k + down3left1] = empty then
          addmove(legal,k,k + down3left1);
        if sq[k + down3] = empty then
          addmove(legal,k,k + down3);
        if sq[k + down3right1] = empty then
          addmove(legal,k,k + down3right1);
        if sq[k + down3right2] = empty then
          addmove(legal,k,k + down3right2);
        if sq[k + down3right3] = empty then
          addmove(legal,k,k + down3right3)
      end; { princess }
      ochief, bchief :
      begin
        { Due to a bug in the Turbo Pascal 5.5 command line compiler,
          the code defining legal moves for the chief
          must be broken up and placed in two separate procedures. }
        chief1;
        chief2
      end { chief }
    end
  end
end; { getlegalmoves }

